## deepin-ai-daemon 1.0.3

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)

project(deepin-ai-daemon)

set(CMAKE_CXX_STANDARD 11)
set(CMAKE_AUTOMOC ON)
set(CMAKE_INCLUDE_CURRENT_DIR ON)

# 内存泄漏检测
# set(CMAKE_CXX_FLAGS "-fsanitize=undefined,address,leak -fno-omit-frame-pointer")
# set(CMAKE_C_FLAGS "-fsanitize=undefined,address,leak -fno-omit-frame-pointer")
# set(CMAKE_Ｌ_FLAGS "-fsanitize=undefined,address,leak -fno-omit-frame-pointer")

find_package(PkgConfig REQUIRED)
find_package(Qt5 COMPONENTS Core REQUIRED)
find_package(Qt5 COMPONENTS Gui REQUIRED)

if(CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
    set(CMAKE_INSTALL_PREFIX /usr)
endif()

# dbus xml dir
set(DBUS_XML_DIR ${CMAKE_SOURCE_DIR}/assets/dbus)

add_subdirectory(src)

=== debian/changelog ===
deepin-ai-daemon (1.0.3-1) unstable; urgency=medium

  * update

 -- Deepin Packages Builder <packages@deepin.com>  Mon, 11 Sep 2023 17:09:45 +0800

deepin-ai-daemon (1.0) unstable; urgency=medium

  * Pre-release for deepin-ai-daemon 1.0

 -- Liu Zhangjian <liuzhangjian@uniontech.com>  Tue, 8 Aug 2023 16:40:00 +0800

=== debian/control ===
Source: deepin-ai-daemon
Section: utils
Priority: optional
Maintainer: Deepin Packages Builder <packages@deepin.com>
Build-Depends: debhelper (>= 9),
 pkg-config,
 qt5-qmake,
 qtbase5-dev,
 libdtkwidget-dev,
 libdtkcore-dev,
 libdtkgui-dev,
 libdtkocr-dev,
 libdtkcore5-bin, 
 cmake,
 libtag1-dev,
 liblucene++-dev,
 libnl-genl-3-dev,
 libicu-dev,
 libboost-filesystem-dev
Standards-Version: 3.9.8
Homepage: http://www.deepin.org/

Package: deepin-ai-daemon
Architecture: any
Depends: 
 ${shlibs:Depends},
 ${misc:Depends},
 deepin-anything-server,
 deepin-ai-models
Recommends:
 libimageeditor (>=1.0.19)
Description: AI search application server for dde-grand-search
 AI search application server for dde-grand-search

## deepin-ai-daemon 1.0.4

=== src/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)

project(deepin-ai-daemon)

set(ANALYZESERVER_XML ${DBUS_XML_DIR}/org.deepin.ai.daemon.AnalyzeServer.xml)

pkg_search_module(NlGenl REQUIRED libnl-genl-3.0 IMPORTED_TARGET)
pkg_check_modules(Lucene REQUIRED IMPORTED_TARGET liblucene++ liblucene++-contrib)
pkg_check_modules(Taglib REQUIRED IMPORTED_TARGET taglib)
pkg_check_modules(ICU REQUIRED IMPORTED_TARGET icu-i18n)

find_package(DtkWidget REQUIRED)
find_package(DtkGui REQUIRED)
find_package(DtkCMake REQUIRED)
find_package(Qt5 COMPONENTS Widgets DBus REQUIRED)
find_package(Boost REQUIRED COMPONENTS system)
find_package(dtkocr REQUIRED)

FILE(GLOB_RECURSE SRC_FILES
    "${CMAKE_CURRENT_SOURCE_DIR}/*.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/*.cpp"
)

FILE(GLOB_RECURSE ANALYZER_SRC
    ${CMAKE_SOURCE_DIR}/3rdparty/analyzer/*.cpp
    ${CMAKE_SOURCE_DIR}/3rdparty/analyzer/*.h
)

qt5_add_dbus_adaptor(SRC_FILES ${ANALYZESERVER_XML}
    server/analyzeserverdbus.h AnalyzeServerDBus)

add_executable(${PROJECT_NAME} ${ANALYZER_SRC} ${SRC_FILES})

target_include_directories(${PROJECT_NAME}
    PRIVATE
        ${CMAKE_SOURCE_DIR}
        ${CMAKE_CURRENT_BINARY_DIR}
        ${DtkWidget_INCLUDE_DIRS}
        ${DtkGUI_INCLUDE_DIRS}
        ${dtkocr_INCLUDE_DIRS}
        ${CMAKE_SOURCE_DIR}/3rdparty
)

target_link_libraries(${PROJECT_NAME}
    Qt5::DBus
    Qt5::Core
    Qt5::Gui
    Qt5::Widgets
    ${Boost_LIBRARIES}
    ${DtkWidget_LIBRARIES}
    ${DtkGUI_LIBRARIES}
    ${dtkocr_LIBRARIES}
    PkgConfig::NlGenl
    PkgConfig::Lucene
    PkgConfig::Taglib
    PkgConfig::ICU
    pthread
)

# bin
install(TARGETS ${PROJECT_NAME} DESTINATION bin)

# services
install(FILES
    ${CMAKE_SOURCE_DIR}/assets/autostart/org.deepin.ai.daemon.service
    ${CMAKE_SOURCE_DIR}/assets/autostart/org.deepin.ai.daemon.AnalyzeServer.service
    DESTINATION ${CMAKE_INSTALL_PREFIX}/share/dbus-1/services)

# systemd service
install(FILES ${CMAKE_SOURCE_DIR}/assets/autostart/deepin-ai-daemon.service
    DESTINATION ${CMAKE_INSTALL_PREFIX}/lib/systemd/user)

# xdg-autostart
install(FILES ${CMAKE_SOURCE_DIR}/assets/autostart/deepin-ai-daemon.desktop
    DESTINATION ${CMAKE_INSTALL_SYSCONFDIR}/xdg/autostart)

=== debian/changelog ===
deepin-ai-daemon (1.0.4-1) unstable; urgency=medium

  * update

 -- Deepin Packages Builder <packages@deepin.com>  Mon, 18 Sep 2023 11:27:48 +0800

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/default.mk

export QT_SELECT = 5

%:
	dh $@ --parallel

override_dh_shlibdeps:
	dh_shlibdeps --dpkg-shlibdeps-params=--ignore-missing-info

override_dh_auto_configure:
	dh_auto_configure -- VERSION=$(VERSION) "-DVERSION=$(DEB_VERSION_UPSTREAM)"

## deepin-ai-daemon 1.1.1

=== CMakeLists.txt ===
# Copyright (c) Facebook, Inc. and its affiliates.
# All rights reserved.
#
# This source code is licensed under the BSD-style license found in the
# LICENSE file in the root directory of this source tree.

# =============================================================================
# Copyright (c) 2023, NVIDIA CORPORATION.
#
# Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
# in compliance with the License. You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software distributed under the License
# is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
# or implied. See the License for the specific language governing permissions and limitations under
# the License.
# =============================================================================

cmake_minimum_required(VERSION 3.22.1 FATAL_ERROR)

set(FAISS_LANGUAGES CXX)

if(FAISS_ENABLE_GPU)
  list(APPEND FAISS_LANGUAGES CUDA)
endif()

if(FAISS_ENABLE_RAFT)
include(cmake/thirdparty/fetch_rapids.cmake)
include(rapids-cmake)
include(rapids-cpm)
include(rapids-cuda)
include(rapids-export)
include(rapids-find)

rapids_cuda_init_architectures(faiss)
rapids_cuda_init_architectures(pyfaiss)
rapids_cuda_init_architectures(faiss_c_library)
endif()

project(faiss
  VERSION 1.8.0
  DESCRIPTION "A library for efficient similarity search and clustering of dense vectors."
  HOMEPAGE_URL "https://github.com/facebookresearch/faiss"
  LANGUAGES ${FAISS_LANGUAGES})
include(GNUInstallDirs)

set(CMAKE_CXX_STANDARD 17)

list(APPEND CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/cmake")

# Valid values are "generic", "avx2", "avx512".
option(FAISS_OPT_LEVEL "" "generic")
option(FAISS_ENABLE_GPU "Enable support for GPU indexes." ON)
option(FAISS_ENABLE_RAFT "Enable RAFT for GPU indexes." OFF)
option(FAISS_ENABLE_PYTHON "Build Python extension." ON)
option(FAISS_ENABLE_C_API "Build C API." OFF)

if(FAISS_ENABLE_GPU)
  set(CMAKE_CUDA_HOST_COMPILER ${CMAKE_CXX_COMPILER})
  enable_language(CUDA)
endif()

if(FAISS_ENABLE_RAFT AND NOT TARGET raft::raft)
   find_package(raft COMPONENTS compiled distributed)
 endif()

add_subdirectory(faiss)

if(FAISS_ENABLE_GPU)
  add_subdirectory(faiss/gpu)
endif()

if(FAISS_ENABLE_PYTHON)
  add_subdirectory(faiss/python)
endif()

if(FAISS_ENABLE_C_API)
  add_subdirectory(c_api)
endif()

add_subdirectory(demos)
add_subdirectory(benchs)
add_subdirectory(tutorial/cpp)

# CTest must be included in the top level to enable `make test` target.
include(CTest)
if(BUILD_TESTING)
  add_subdirectory(tests)

  if(FAISS_ENABLE_GPU)
    add_subdirectory(faiss/gpu/test)
  endif()
endif()

=== 3rdparty/CMakeLists.txt ===

# for faiss
set(FAISS_ENABLE_GPU OFF)
set(FAISS_ENABLE_PYTHON OFF)
set(BUILD_TESTING OFF)

if (EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/faiss")
    message("find faiss")
else()
    message("decompression faiss")
    execute_process(
        COMMAND tar -xzvf faiss.tar.gz
        WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
        RESULT_VARIABLE TAR_RESULT
    )

    if (NOT TAR_RESULT EQUAL "0")
        message(FATAL_ERROR "tar faiss.tar.gz failed: ${TAR_RESULT}")
    endif()
endif()

add_subdirectory(faiss)

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -3,16 +3,18 @@
 project(deepin-ai-daemon)
 
 set(ANALYZESERVER_XML ${DBUS_XML_DIR}/org.deepin.ai.daemon.AnalyzeServer.xml)
+set(VectorIndex_XML ${DBUS_XML_DIR}/org.deepin.ai.daemon.VectorIndex.xml)
 
 pkg_search_module(NlGenl REQUIRED libnl-genl-3.0 IMPORTED_TARGET)
 pkg_check_modules(Lucene REQUIRED IMPORTED_TARGET liblucene++ liblucene++-contrib)
 pkg_check_modules(Taglib REQUIRED IMPORTED_TARGET taglib)
 pkg_check_modules(ICU REQUIRED IMPORTED_TARGET icu-i18n)
+pkg_check_modules(Docparser REQUIRED IMPORTED_TARGET docparser)
 
 find_package(DtkWidget REQUIRED)
 find_package(DtkGui REQUIRED)
 find_package(DtkCMake REQUIRED)
-find_package(Qt5 COMPONENTS Widgets DBus REQUIRED)
+find_package(Qt5 COMPONENTS Widgets DBus Sql REQUIRED)
 find_package(Boost REQUIRED COMPONENTS system)
 find_package(dtkocr REQUIRED)
 
@@ -29,6 +31,9 @@
 qt5_add_dbus_adaptor(SRC_FILES ${ANALYZESERVER_XML}
     server/analyzeserverdbus.h AnalyzeServerDBus)
 
+qt5_add_dbus_adaptor(SRC_FILES ${VectorIndex_XML}
+    server/vectorindexdbus.h VectorIndexDBus)
+
 add_executable(${PROJECT_NAME} ${ANALYZER_SRC} ${SRC_FILES})
 
 target_include_directories(${PROJECT_NAME}
@@ -38,6 +43,7 @@
         ${DtkWidget_INCLUDE_DIRS}
         ${DtkGUI_INCLUDE_DIRS}
         ${dtkocr_INCLUDE_DIRS}
+        ${faiss_INCLUDE_DIRS}
         ${CMAKE_SOURCE_DIR}/3rdparty
 )
 
@@ -46,6 +52,7 @@
     Qt5::Core
     Qt5::Gui
     Qt5::Widgets
+    Qt5::Sql
     ${Boost_LIBRARIES}
     ${DtkWidget_LIBRARIES}
     ${DtkGUI_LIBRARIES}
@@ -54,7 +61,10 @@
     PkgConfig::Lucene
     PkgConfig::Taglib
     PkgConfig::ICU
+    PkgConfig::Docparser
     pthread
+    faiss
+    uchardet
 )
 
 # bin
@@ -64,6 +74,7 @@
 install(FILES
     ${CMAKE_SOURCE_DIR}/assets/autostart/org.deepin.ai.daemon.service
     ${CMAKE_SOURCE_DIR}/assets/autostart/org.deepin.ai.daemon.AnalyzeServer.service
+    ${CMAKE_SOURCE_DIR}/assets/autostart/org.deepin.ai.daemon.VectorIndex.service
     DESTINATION ${CMAKE_INSTALL_PREFIX}/share/dbus-1/services)
 
 # systemd service
@@ -73,3 +84,7 @@
 # xdg-autostart
 install(FILES ${CMAKE_SOURCE_DIR}/assets/autostart/deepin-ai-daemon.desktop
     DESTINATION ${CMAKE_INSTALL_SYSCONFDIR}/xdg/autostart)
+
+# install Manual App icon
+install(FILES ${CMAKE_SOURCE_DIR}/assets/icon/deepin-ai-daemon.svg
+    DESTINATION ${CMAKE_INSTALL_PREFIX}/share/icons/hicolor/scalable/apps)

=== tests/CMakeLists.txt ===
# Copyright (c) Facebook, Inc. and its affiliates.
# All rights reserved.
#
# This source code is licensed under the BSD-style license found in the
# LICENSE file in the root directory of this source tree.

set(FAISS_TEST_SRC
  test_binary_flat.cpp
  test_dealloc_invlists.cpp
  test_ivfpq_codec.cpp
  test_ivfpq_indexing.cpp
  test_lowlevel_ivf.cpp
  test_ivf_index.cpp
  test_merge.cpp
  test_omp_threads.cpp
  test_ondisk_ivf.cpp
  test_pairs_decoding.cpp
  test_params_override.cpp
  test_pq_encoding.cpp
  test_sliding_ivf.cpp
  test_threaded_index.cpp
  test_transfer_invlists.cpp
  test_mem_leak.cpp
  test_cppcontrib_sa_decode.cpp
  test_cppcontrib_uintreader.cpp
  test_simdlib.cpp
  test_approx_topk.cpp
  test_RCQ_cropping.cpp
  test_distances_simd.cpp
  test_heap.cpp
  test_code_distance.cpp
  test_hnsw.cpp
  test_partitioning.cpp
  test_fastscan_perf.cpp
)

add_executable(faiss_test ${FAISS_TEST_SRC})

if(NOT FAISS_OPT_LEVEL STREQUAL "avx2" AND NOT FAISS_OPT_LEVEL STREQUAL "avx512")
  target_link_libraries(faiss_test PRIVATE faiss)
endif()

if(FAISS_OPT_LEVEL STREQUAL "avx2")
  if(NOT WIN32)
    target_compile_options(faiss_test PRIVATE $<$<COMPILE_LANGUAGE:CXX>:-mavx2 -mfma>)
  else()
    target_compile_options(faiss_test PRIVATE $<$<COMPILE_LANGUAGE:CXX>:/arch:AVX2>)
  endif()
  target_link_libraries(faiss_test PRIVATE faiss_avx2)
endif()

if(FAISS_OPT_LEVEL STREQUAL "avx512")
  if(NOT WIN32)
    target_compile_options(faiss_test PRIVATE $<$<COMPILE_LANGUAGE:CXX>:-mavx2 -mfma -mavx512f -mavx512f -mavx512cd -mavx512vl -mavx512dq -mavx512bw>)
  else()
    target_compile_options(faiss_test PRIVATE $<$<COMPILE_LANGUAGE:CXX>:/arch:AVX512>)
  endif()
  target_link_libraries(faiss_test PRIVATE faiss_avx512)
endif()

include(FetchContent)
FetchContent_Declare(googletest
  URL "https://github.com/google/googletest/archive/release-1.12.1.tar.gz")
set(BUILD_GMOCK CACHE BOOL OFF)
set(INSTALL_GTEST CACHE BOOL OFF)
FetchContent_MakeAvailable(googletest)

find_package(OpenMP REQUIRED)

target_link_libraries(faiss_test PRIVATE
  OpenMP::OpenMP_CXX
  gtest_main
  $<$<BOOL:${FAISS_ENABLE_RAFT}>:raft::raft>
)

# Defines `gtest_discover_tests()`.
include(GoogleTest)
gtest_discover_tests(faiss_test)

=== faiss/python/CMakeLists.txt ===
# Copyright (c) Facebook, Inc. and its affiliates.
# All rights reserved.
#
# This source code is licensed under the BSD-style license found in the
# LICENSE file in the root directory of this source tree.

cmake_minimum_required(VERSION 3.17 FATAL_ERROR)

project(pyfaiss
  DESCRIPTION "Python bindings for faiss."
  HOMEPAGE_URL "https://github.com/facebookresearch/faiss"
  LANGUAGES CXX)

set(CMAKE_CXX_STANDARD 17)

find_package(SWIG REQUIRED COMPONENTS python)
include(${SWIG_USE_FILE})

set(UseSWIG_TARGET_NAME_PREFERENCE STANDARD)
set(SWIG_SOURCE_FILE_EXTENSIONS swig)

macro(configure_swigfaiss source)
  set_source_files_properties(${source} PROPERTIES
    CPLUSPLUS ON
    USE_TARGET_INCLUDE_DIRECTORIES TRUE
  )
  if(NOT ${CMAKE_SYSTEM_NAME} MATCHES "Darwin" AND NOT WIN32)
    set_source_files_properties(${source} PROPERTIES
      SWIG_FLAGS -DSWIGWORDSIZE64
    )
  endif()
  if(WIN32)
    set_source_files_properties(${source} PROPERTIES
      SWIG_FLAGS -DSWIGWIN
    )
  endif()
  if(FAISS_ENABLE_GPU)
    set_source_files_properties(${source} PROPERTIES
      COMPILE_DEFINITIONS GPU_WRAPPER
    )
  endif()
endmacro()

# CMake's SWIG wrappers only allow tweaking certain settings at source level, so
# we duplicate the source in order to override the module name.
configure_file(swigfaiss.swig ${CMAKE_CURRENT_SOURCE_DIR}/swigfaiss_avx2.swig COPYONLY)
configure_file(swigfaiss.swig ${CMAKE_CURRENT_SOURCE_DIR}/swigfaiss_avx512.swig COPYONLY)

configure_swigfaiss(swigfaiss.swig)
configure_swigfaiss(swigfaiss_avx2.swig)
configure_swigfaiss(swigfaiss_avx512.swig)

if(TARGET faiss)
  # Manually add headers as extra dependencies of swigfaiss.
  set(SWIG_MODULE_swigfaiss_EXTRA_DEPS)
  foreach(h ${FAISS_HEADERS})
    list(APPEND SWIG_MODULE_swigfaiss_EXTRA_DEPS "${faiss_SOURCE_DIR}/faiss/${h}")
    list(APPEND SWIG_MODULE_swigfaiss_avx2_EXTRA_DEPS "${faiss_SOURCE_DIR}/faiss/${h}")
    list(APPEND SWIG_MODULE_swigfaiss_avx512_EXTRA_DEPS "${faiss_SOURCE_DIR}/faiss/${h}")
  endforeach()
  foreach(h ${FAISS_GPU_HEADERS})
    list(APPEND SWIG_MODULE_swigfaiss_EXTRA_DEPS "${faiss_SOURCE_DIR}/faiss/gpu/${h}")
    list(APPEND SWIG_MODULE_swigfaiss_avx2_EXTRA_DEPS "${faiss_SOURCE_DIR}/faiss/gpu/${h}")
    list(APPEND SWIG_MODULE_swigfaiss_avx512_EXTRA_DEPS "${faiss_SOURCE_DIR}/faiss/gpu/${h}")
  endforeach()
else()
  find_package(faiss REQUIRED)
endif()

swig_add_library(swigfaiss
  TYPE SHARED
  LANGUAGE python
  SOURCES swigfaiss.swig
)
set_property(TARGET swigfaiss PROPERTY SWIG_COMPILE_OPTIONS -doxygen)

set_property(SOURCE swigfaiss_avx2.swig
  PROPERTY SWIG_MODULE_NAME swigfaiss_avx2)
swig_add_library(swigfaiss_avx2
  TYPE SHARED
  LANGUAGE python
  SOURCES swigfaiss_avx2.swig
)
set_property(TARGET swigfaiss_avx2 PROPERTY SWIG_COMPILE_OPTIONS -doxygen)
if(NOT FAISS_OPT_LEVEL STREQUAL "avx2")
  set_target_properties(swigfaiss_avx2 PROPERTIES EXCLUDE_FROM_ALL TRUE)
endif()

set_property(SOURCE swigfaiss_avx512.swig
  PROPERTY SWIG_MODULE_NAME swigfaiss_avx512)
swig_add_library(swigfaiss_avx512
  TYPE SHARED
  LANGUAGE python
  SOURCES swigfaiss_avx512.swig
)
set_property(TARGET swigfaiss_avx512 PROPERTY SWIG_COMPILE_OPTIONS -doxygen)
if(NOT FAISS_OPT_LEVEL STREQUAL "avx512")
  set_target_properties(swigfaiss_avx512 PROPERTIES EXCLUDE_FROM_ALL TRUE)
endif()

if(NOT WIN32)
  # NOTE: Python does not recognize the dylib extension.
  set_target_properties(swigfaiss PROPERTIES SUFFIX .so)
  set_target_properties(swigfaiss_avx2 PROPERTIES SUFFIX .so)
  set_target_properties(swigfaiss_avx512 PROPERTIES SUFFIX .so)
else()
  # we need bigobj for the swig wrapper
  target_compile_options(swigfaiss PRIVATE /bigobj)
  target_compile_options(swigfaiss_avx2 PRIVATE /bigobj)
  target_compile_options(swigfaiss_avx512 PRIVATE /bigobj)
endif()

if(FAISS_ENABLE_GPU)
  find_package(CUDAToolkit REQUIRED)
  if(FAISS_ENABLE_RAFT)
    find_package(raft COMPONENTS compiled distributed)
  endif()
  target_link_libraries(swigfaiss PRIVATE CUDA::cudart $<$<BOOL:${FAISS_ENABLE_RAFT}>:raft::raft> $<$<BOOL:${FAISS_ENABLE_RAFT}>:nvidia::cutlass::cutlass>)
  target_link_libraries(swigfaiss_avx2 PRIVATE CUDA::cudart $<$<BOOL:${FAISS_ENABLE_RAFT}>:raft::raft> $<$<BOOL:${FAISS_ENABLE_RAFT}>:nvidia::cutlass::cutlass>)
  target_link_libraries(swigfaiss_avx512 PRIVATE CUDA::cudart $<$<BOOL:${FAISS_ENABLE_RAFT}>:raft::raft> $<$<BOOL:${FAISS_ENABLE_RAFT}>:nvidia::cutlass::cutlass>)
endif()

find_package(OpenMP REQUIRED)

target_link_libraries(swigfaiss PRIVATE
  faiss
  Python::Module
  Python::NumPy
  OpenMP::OpenMP_CXX
)

target_link_libraries(swigfaiss_avx2 PRIVATE
  faiss_avx2
  Python::Module
  Python::NumPy
  OpenMP::OpenMP_CXX
)

target_link_libraries(swigfaiss_avx512 PRIVATE
  faiss_avx512
  Python::Module
  Python::NumPy
  OpenMP::OpenMP_CXX
)

# Hack so that python_callbacks.h can be included as
# `#include <faiss/python/python_callbacks.h>`.
target_include_directories(swigfaiss PRIVATE ${PROJECT_SOURCE_DIR}/../..)
target_include_directories(swigfaiss_avx2 PRIVATE ${PROJECT_SOURCE_DIR}/../..)
target_include_directories(swigfaiss_avx512 PRIVATE ${PROJECT_SOURCE_DIR}/../..)

find_package(Python REQUIRED
  COMPONENTS Development NumPy
)

add_library(faiss_python_callbacks EXCLUDE_FROM_ALL
  python_callbacks.cpp
)
set_property(TARGET faiss_python_callbacks
  PROPERTY POSITION_INDEPENDENT_CODE ON
)

# Hack so that python_callbacks.h can be included as
# `#include <faiss/python/python_callbacks.h>`.
target_include_directories(faiss_python_callbacks PRIVATE ${PROJECT_SOURCE_DIR}/../..)
target_include_directories(faiss_python_callbacks PRIVATE ${Python_INCLUDE_DIRS})

target_link_libraries(swigfaiss PRIVATE faiss_python_callbacks)
target_link_libraries(swigfaiss_avx2 PRIVATE faiss_python_callbacks)
target_link_libraries(swigfaiss_avx512 PRIVATE faiss_python_callbacks)

configure_file(setup.py setup.py COPYONLY)
configure_file(__init__.py __init__.py COPYONLY)
configure_file(loader.py loader.py COPYONLY)
configure_file(class_wrappers.py class_wrappers.py COPYONLY)
configure_file(gpu_wrappers.py gpu_wrappers.py COPYONLY)
configure_file(extra_wrappers.py extra_wrappers.py COPYONLY)
configure_file(array_conversions.py array_conversions.py COPYONLY)

file(GLOB files "${PROJECT_SOURCE_DIR}/../../contrib/*.py")
file(COPY ${files} DESTINATION contrib/)

=== faiss/gpu/test/CMakeLists.txt ===
# Copyright (c) Facebook, Inc. and its affiliates.
# All rights reserved.
#
# This source code is licensed under the BSD-style license found in the
# LICENSE file in the root directory of this source tree.
# =============================================================================
# Copyright (c) 2023, NVIDIA CORPORATION.
#
# Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
# in compliance with the License. You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software distributed under the License
# is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
# or implied. See the License for the specific language governing permissions and limitations under
# the License.
# =============================================================================

find_package(CUDAToolkit REQUIRED)

# Defines `gtest_discover_tests()`.
include(GoogleTest)

add_library(faiss_gpu_test_helper TestUtils.cpp)
target_link_libraries(faiss_gpu_test_helper PUBLIC faiss gtest CUDA::cudart $<$<BOOL:${FAISS_ENABLE_RAFT}>:raft::raft> $<$<BOOL:${FAISS_ENABLE_RAFT}>:raft::compiled>)

macro(faiss_gpu_test file)
  get_filename_component(test_name ${file} NAME_WE)
  add_executable(${test_name} ${file})
  target_link_libraries(${test_name} PRIVATE faiss_gpu_test_helper)
  gtest_discover_tests(${test_name})
endmacro()


faiss_gpu_test(TestCodePacking.cpp)
faiss_gpu_test(TestGpuIndexFlat.cpp)
faiss_gpu_test(TestGpuIndexIVFFlat.cpp)
faiss_gpu_test(TestGpuIndexBinaryFlat.cpp)
faiss_gpu_test(TestGpuMemoryException.cpp)
faiss_gpu_test(TestGpuIndexIVFPQ.cpp)
faiss_gpu_test(TestGpuIndexIVFScalarQuantizer.cpp)
faiss_gpu_test(TestGpuDistance.cu)
faiss_gpu_test(TestGpuSelect.cu)

add_executable(demo_ivfpq_indexing_gpu EXCLUDE_FROM_ALL
  demo_ivfpq_indexing_gpu.cpp)

target_link_libraries(demo_ivfpq_indexing_gpu
  PRIVATE faiss gtest_main CUDA::cudart)

=== debian/changelog ===
deepin-ai-daemon (1.1.1) unstable; urgency=medium

  * Pre-release for deepin-ai-daemon 1.1.1

 -- zhuangyu <zhangyub@uniontech.com>  Wed, 7 Aug 2024 21:12:10 +0800
 

=== debian/control ===
--- 
+++ 
@@ -16,7 +16,11 @@
  liblucene++-dev,
  libnl-genl-3-dev,
  libicu-dev,
- libboost-filesystem-dev
+ libboost-filesystem-dev,
+ libblas-dev,
+ liblapack-dev,
+ libdocparser-dev,
+ libuchardet-dev
 Standards-Version: 3.9.8
 Homepage: http://www.deepin.org/
 
@@ -25,8 +29,7 @@
 Depends: 
  ${shlibs:Depends},
  ${misc:Depends},
- deepin-anything-server,
- deepin-ai-models
+ deepin-anything-server
 Recommends:
  libimageeditor (>=1.0.19)
 Description: AI search application server for dde-grand-search
